' FFSubmenu=Tools
' FFName=Konfigurator
' FFScriptFiles=konfigurator.vbs
' div. Einstellungen und Datensicherungen in FF
' KGsoft (praetor)
' Version 1.4 vom 01.01.2012
' Version 1.7 vom 27.03.2012	kleine Korrektur
' Version 1.8 vom 09.04.2012	Tooltipp Computeransicht
' Version 1.9 vom 20.04.2012	32/64Bit-Analyse verbessert, Fehler abgefangen
' Version 2.0 vom 22.05.2012	Fehler in Makroauslesen abgefangen
' Version 2.1 vom 14.06.2012	weitere Fehler abfangen
' Version 2.2 vom 30.12.2012	zwei Sets fr Ansichten
'								Namen der gespeicherten Ansichten per Tooltip
'								Kopie des Skripts und der gespeicherten Daten in der Dropbox
' Version 2.3 vom 31.12.2012	Kurzhilfe und erweiterte Tooltips
' Version 2.4 vom 25.04.2013	Erfolgsmeldung nach Dropbox-Kopie
'								Tooltipp Computeransicht erweitert
' Version 2.5 vom 20.02.2014	max. Anzahl Belichter auf 40 gesetzt, Tooltipp-Standard als Basis, erweiterte Tooltips
' Version 2.6 vom 01.04.2015	Korrektur bei <Tooltipp-Standard als Basis>
' Version 2.7 vom 06.04.2015	Ablage in der Dropbox in einem Unterordner yymmdd
' Version 3.0 vom 02.08.2016	Dropbox-Ordner wird automatisch ermittelt

' was fehlt:  Bilderlisten, Stapel, Makros, Skripte, eigene Tooltipps

Option Explicit
Const Version = "V 3.0"
' ** hier den Pfad zum lokalen Dropbox-Ordner eintragen
REM Const Dropboxpfad = "c:\Users\Andreas\Dropbox\"
Dim DBPfad
' **
Const HeadImage = "head.png"
Const ButImage1 = "muelleimer1.png"
Const ForReading = 1, ForWriting = 2
Dim fso, f
Set fso = CreateObject("Scripting.FileSystemObject")
Dim Keywert
Dim inifeld			' fr die Belichter
Dim inifeld2		' fr die Dialog-Zusammenstellungen
Dim i, u, PFeld(40,3)
Dim pa, pfeldzeiger
Dim makrofeld, stapelfeld, seitenfeld, obkorfeld, farbkorfeld
Dim FTPDPath, FTPPath, FTPPwd, FTPServer, FTPUser, PassiveFTP, UseForumFTP
Dim delansicht
Dim doit
Dim oWSHShell
Dim Aufruf
Dim backuppfad
Dim aktFFVersion
Dim STastenarray, stastzaehler
Dim phfeld
Dim ttauswahl, ttdatei
Dim Tooltiptext, standarttipptext
Dim aktdatum
Set oWSHShell = CreateObject("WScript.Shell")

i = 0
u = 0
pa = 0
pfeldzeiger = 0

Call Dialogaufbau
Call INIauslesenBelichter
Call Makroauslesen
Call Stapelauslesen
Call Seitenauslesen
Call Obkorauslesen
Call Farbkorauslesen
Call Ansichtenauslesen
Call Dialogauswertung

Sub DialogAuswertung
	FF_SetDialogTimer "Konfigurator", 100  
	do										' Auswertung Button im Dialog
		Select Case FF_ShowDialog("Konfigurator")
			Case "TIMER"					' Startwerte festlegen
				FF_SetControl "Konfigurator","Version", Version		' Version des Skripts
				' aktuell laufende FF-Version ermitteln
				aktFFVersion = FF_GetMajor & "." & FF_GetMinor & " build " & FF_GetBuild
				If Is64Bit() Then 
					aktFFVersion = aktFFVersion & " (64 Bit)"
				Else
					aktFFVersion = aktFFVersion & " (32 Bit)"
				End If
				FF_SetControl "Konfigurator","aktFFVersion", aktFFVersion
				' ** gespeicherte Ansichten
				' Set I
				If not fso.FileExists(FF_GetFFPathEx(2) & "\Konfigurator\ansichten.reg") Then
					FF_EnableControl "Konfigurator", "Einlesen", False
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "Speicherdatum", ""
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "FF-Version", ""
				End If
				FF_SetControl "Konfigurator", "ansichtsave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "Speicherdatum")
				FF_SetControl "Konfigurator", "ffvers_ansicht_stat", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "FF-Version")
				' Set II
				If not fso.FileExists(FF_GetFFPathEx(2) & "\Konfigurator\ansichten2.reg") Then
					FF_EnableControl "Konfigurator", "||||||||Einlesen", False
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "Speicherdatum", ""
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "FF-Version", ""
				End If
				FF_SetControl "Konfigurator", "ansichtsave2", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "Speicherdatum")
				FF_SetControl "Konfigurator", "ffvers_ansicht_stat2", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "FF-Version")
				' ** Nummerierung Computeransicht
				On Error Resume Next		' Fehler abfangen, wenn der Schlssel gar nicht existiert
				Keywert = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\CBNumber")
				On Error Goto 0
				If  Keywert = 1 Then 		' Nummerierung ist on
					FF_SetControl "Konfigurator","numein_bool", "1"
				Else
					FF_SetControl "Konfigurator","numaus_bool", "1"
				End If
				' ** Dialoge (Einstellungen)
				If not fso.FileExists(FF_GetFFPathEx(2) & "\Konfigurator\FixFotoValues.ini") Then
					FF_EnableControl "Konfigurator", "|Einlesen", False
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "Speicherdatum", ""
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "FF-Version", ""
				End If
				FF_SetControl "Konfigurator", "dialogsave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "Speicherdatum")
				FF_SetControl "Konfigurator", "ffvers_dialog_stat", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "FF-Version")
				FF_SetControl "Konfigurator","abfrag_bool", "1"
				' ** Dialog-Zusammenstellungen
				If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialogzusammenstellungen", "Speicherdatum") = "" Then
					FF_EnableControl "Konfigurator", "||||Einlesen", False
				End If
				FF_SetControl "Konfigurator","diazusave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialogzusammenstellungen", "Speicherdatum")
				FF_SetControl "Konfigurator","ffvers_diazu_stat", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialogzusammenstellungen", "FF-Version")
				' ** FTP-Einstellungen
				FF_SetControl "Konfigurator", "ftp_save", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "Speicherdatum")
				FF_SetControl "Konfigurator", "ff_vers_ftp_save", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FF-Version")
				If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "Speicherdatum") = "" Then
					FF_EnableControl "Konfigurator", "|||Einlesen", False
				End If
				' ** Tastenbelegung
				FF_SetControl "Konfigurator", "tastensave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Tastaturkuerzel", "Speicherdatum")
				FF_SetControl "Konfigurator", "ff_vers_tast", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Tastaturkuerzel", "FF-Version")
				If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Tastaturkuerzel", "Speicherdatum") = "" Then
					FF_EnableControl "Konfigurator", "|||||Einlesen", False
				End If
				' ** Skript-Tastenbelegung
				FF_SetControl "Konfigurator", "stastensave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "Speicherdatum")
				FF_SetControl "Konfigurator", "ff_vers_stasten", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "FF-Version")
				If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "Speicherdatum") = "" Then
					FF_EnableControl "Konfigurator", "|||||||Einlesen", False
				End If
				' ** Externe Programme-Parameter
				FF_SetControl "Konfigurator", "extpsave", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "ExtProg", "Speicherdatum")
				FF_SetControl "Konfigurator", "ff_vers_exp", ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "ExtProg", "FF-Version")
				If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "ExtProg", "Speicherdatum") = "" Then
					FF_EnableControl "Konfigurator", "||||||Einlesen", False
				End If

				FF_SetDialogTimer "Konfigurator", 0	' Timer-Event wird nur 1x erzeugt
			Case "Lschen"										' Belicher lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					for u = 0 to pfeldzeiger - 1
						If FF_GetControl ("Konfigurator","belichter_combo") = PFeld(u, 0) Then
							For i = PFeld(u, 1) to PFeld(u, 2)		' Belichtereintrge im INIFeld lschen
								inifeld(i) = ""
							Next
						End If
					Next
					Call INIschreiben
					i = 0
					u = 0
					pa = 0
					pfeldzeiger = 0
					FF_SetControl "Konfigurator","belichter_combo", "" 	' Combo leeren
					Call INIauslesenBelichter
				End If
			Case "|Lschen"											' Makro lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					If FF_GetControl("Konfigurator","makro_combo") <> "" Then
						Set f = fso.OpenTextFile(FF_GetFFPathEx(1) & "\Batch\Macros.ini", ForWriting)
						For u = 0 to ubound(makrofeld) -1
							if InStr(makrofeld(u), FF_GetControl("Konfigurator","makro_combo")) = 0 Then f.WriteLine makrofeld(u)
						Next
						FF_SetControl "Konfigurator","makro_combo", "" 		' Combo leeren
						Call Makroauslesen
					End If
				End If
			Case "||Lschen"										' Stapel lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					If FF_GetControl("Konfigurator","stapel_combo") <> "" Then
						fso.DeleteFile(FF_GetFFPathEx(1) & "\Batch\" & FF_GetControl("Konfigurator","stapel_combo") & "*.fbi")
						' +++ evtl.vorhandenes gleichnamiges Makro lschen
							Set f = fso.OpenTextFile(FF_GetFFPathEx(1) & "\Batch\Macros.ini", ForWriting)
							For u = 0 to ubound(makrofeld) -1
								if InStr(makrofeld(u), FF_GetControl("Konfigurator","stapel_combo")) = 0 Then f.WriteLine makrofeld(u)
							Next
							FF_SetControl "Konfigurator","makro_combo", "" 		' Combo leeren
							Call Makroauslesen
						' +++
						FF_SetControl "Konfigurator","stapel_combo", "" 		' Combo leeren
						Call Stapelauslesen
					End If
				End If
			Case "|||Lschen"											' Seitenvorlagen lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					If  FF_GetControl("Konfigurator","seiten_combo") <> "" Then
						fso.DeleteFile(FF_GetFFPathEx(6) & "\" & FF_GetControl("Konfigurator","seiten_combo") & "*.ini")
						FF_SetControl "Konfigurator","seiten_combo", "" 		' Combo leeren
						Call Seitenauslesen
					End If
				End If
			Case "||||Lschen"			' Objektkorrektur lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					If FF_GetControl("Konfigurator","obkor_combo") <> "" Then
						fso.DeleteFile(FF_GetFFPathEx(1) & "\" & FF_GetControl("Konfigurator","obkor_combo") & "*.ff")
						FF_SetControl "Konfigurator","obkor_combo", "" 			' Combo leeren
						Call Seitenauslesen
					End If
				End If
			Case "|||||Lschen"			' Farbsaumkorrektur lschen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					If FF_GetControl("Konfigurator","farbkor_combo") <> "" Then
						fso.DeleteFile(FF_GetFFPathEx(1) & "\" & FF_GetControl("Konfigurator","farbkor_combo") & "*.cff")
						FF_SetControl "Konfigurator","farbkor_combo", "" 		' Combo leeren
						Call Seitenauslesen	
					End If
				End If
			' ** Nummerierung in der Computeransicht
			Case "numein_bool"
				If FF_GetControl("Konfigurator","numein_bool") = "1" Then
					FF_SetControl "Konfigurator","numaus_bool", "0"
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\CBNumber", "00000001", "REG_DWORD"
					Msgbox "FixFoto muss einmal neu gestartet werden, damit die nderung wirksam wird.", 64, "Konfigurator"
				End If
			Case "numaus_bool"
				If FF_GetControl("Konfigurator","numaus_bool") = "1" Then
					FF_SetControl "Konfigurator","numein_bool", "0"
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\CBNumber", "00000000", "REG_DWORD"
					Msgbox "FixFoto muss einmal neu gestartet werden, damit die nderung wirksam wird.", 64, "Konfigurator"
				End If
			' *** aktuelle Ansicht ***
			REM Case "||Sichern"
				REM if MsgBox ("Nach einer nderung der Standardeinstellung kann diese erst gesichert wertden, nachdem FixFoto einmal neu gestartet wurde", 36) = 6 Then
					REM Aufruf = "regedit.exe /e " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\akutansicht.reg" &  Chr(34) & " " & Chr(34) & "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Settings" & Chr(34)
					REM oWSHShell.Run Aufruf
					REM FF_SetControl "Konfigurator","akutansichtsave", Date
					REM FF_SetControl "Konfigurator","ffvers_akutansicht_stat", FFVersion
					REM FF_EnableControl "Konfigurator", "||Einlesen", True
					REM WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "AktuelleAnsichten", "Speicherdatum", Date
					REM WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "AktuelleAnsichten", "FF-Version", FFVersion
				REM End If
			REM Case "||Einlesen"
				REM doit = 1
				REM If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					REM If MsgBox ("AUF EIGENE GEFAHR!" & vbNewLine & vbNewLine &"Die bernahme von FF-Einstellungen aus einer Vorversion wird standardmig von FixFoto nicht untersttzt, weil u.U. ein instabiler Zustand entstehen kann." & vbNewLine & vbNewLine & "Sollen die aktuell in FF hinterlegten Ansichten tatschlich durch die gespeicherten Ansichten ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				REM End If
				REM If doit = 1 Then
					REM Aufruf = "regedit.exe /s " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\akutansicht.reg" & Chr(34)
					REM oWSHShell.Run Aufruf
				REM End If
			' *** gespeicherte Ansichten ***	
			Case "Sichern"			' Set I - Ansichten sichern
				Aufruf = "regedit.exe /e " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ansichten.reg" &  Chr(34) & " " & Chr(34) & "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\SaveState" & Chr(34)
				REM msgbox aufruf
				oWSHShell.Run Aufruf
				FF_SetControl "Konfigurator","ansichtsave", Date
				FF_SetControl "Konfigurator","ffvers_ansicht_stat", FFVersion
				FF_EnableControl "Konfigurator", "Einlesen", True
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "FF-Version", FFVersion
				' Tooltip
				Call Ansichtenauslesen		' hier nur, um Tooltiptext zu ermitteln
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "Tooltip", Tooltiptext
				Call Tooltipp_Ansichten
			Case "Einlesen"			' Set I - Ansichten einlesen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("AUF EIGENE GEFAHR!" & vbNewLine & vbNewLine &"Die bernahme von FF-Einstellungen aus einer Vorversion wird standardmig von FixFoto nicht untersttzt, weil u.U. ein instabiler Zustand entstehen kann." & vbNewLine & vbNewLine & "Sollen die aktuell in FF hinterlegten Ansichten tatschlich durch die gespeicherten Ansichten ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					Aufruf = "regedit.exe /s " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ansichten.reg" & Chr(34)
					oWSHShell.Run Aufruf,,True
				End If
				Call Ansichtenauslesen		' Liste der lschbaren Ansichten aktualisieren
			Case "||||||||Sichern"			' Set II - Ansichten sichern
				Aufruf = "regedit.exe /e " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ansichten2.reg" &  Chr(34) & " " & Chr(34) & "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\SaveState" & Chr(34)
				REM msgbox aufruf
				oWSHShell.Run Aufruf
				FF_SetControl "Konfigurator","ansichtsave2", Date
				FF_SetControl "Konfigurator","ffvers_ansicht_stat2", FFVersion
				FF_EnableControl "Konfigurator", "||||||||Einlesen", True
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "FF-Version", FFVersion
				' Tooltip
				Call Ansichtenauslesen		' hier nur, um Tooltiptext zu ermitteln
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "Tooltip", Tooltiptext
				Call Tooltipp_Ansichten
			Case "||||||||Einlesen"			' Set II - Ansichten einlesen
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("AUF EIGENE GEFAHR!" & vbNewLine & vbNewLine &"Die bernahme von FF-Einstellungen aus einer Vorversion wird standardmig von FixFoto nicht untersttzt, weil u.U. ein instabiler Zustand entstehen kann." & vbNewLine & vbNewLine & "Sollen die aktuell in FF hinterlegten Ansichten tatschlich durch die gespeicherten Ansichten ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					Aufruf = "regedit.exe /s " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ansichten2.reg" & Chr(34)
					oWSHShell.Run Aufruf,,True
				End If
				Call Ansichtenauslesen		' Liste der lschbaren Ansichten aktualisieren	
			' ** Dialoge (gespeicherte Einstellungen) / Textliste**
			Case "|Sichern"
				If fso.FileExists(FF_GetFFPathEx(1) & "\FixFotoValues.ini") Then
					fso.CopyFile FF_GetFFPathEx(1) & "\FixFotoValues.ini", FF_GetFFPathEx(2) & "\Konfigurator\FixFotoValues.ini"
					FF_SetControl "Konfigurator","dialogsave", Date
					FF_SetControl "Konfigurator","ffvers_dialog_stat", FFVersion
					FF_EnableControl "Konfigurator", "|Einlesen", True
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "Speicherdatum", Date
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialoge", "FF-Version", FFVersion
				Else
					MsgBox "Es gibt keine Einstellungen fr Multidialoge und Optimierungs-Automatiken bzw. keine Textliste, die gespeichert werden knnte.", 64, "Konfigurator (FixFotoValues.ini)"
				End If
			Case "|Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuell in FF hinterlegten Einstellungen fr Multidialoge und Optimierungs-Automatiken tatschlich durch die gespeicherten Einstellungen ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					fso.CopyFile FF_GetFFPathEx(2) & "\Konfigurator\FixFotoValues.ini", FF_GetFFPathEx(1) & "\FixFotoValues.ini"
				End If
			' ** FTP-Daten
			Case "|||Sichern"
				' FTP-Zugnge fr Web-Listen
				Aufruf = "regedit.exe /e " & Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ftp1.reg" & Chr(34) & " "& Chr(34) & "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\FTP" & Chr(34)
				REM MsgBox aufruf
				oWSHShell.Run Aufruf
				' FTP-Zugang fr Speichern unter
				On Error Resume Next		' Fehler abfangen, wenn der Schlssel gar nicht existiert
				FTPDPath = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPDPath")
				FTPPath = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPPath")
				FTPPwd = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPPwd")
				FTPServer = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPServer")
				FTPUser = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPUser")
				PassiveFTP = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\PassiveFTP")
				UseForumFTP = oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\UseForumFTP")
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPDPath", FTPDPath
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPPath", FTPPath
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPPwd", FTPPwd
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPServer", FTPServer
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPUser", FTPUser
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "PassiveFTP", PassiveFTP
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "UseForumFTP", UseForumFTP
				On Error Goto 0
				FF_SetControl "Konfigurator","ftp_save", Date
				FF_SetControl "Konfigurator","ff_vers_ftp_save", FFVersion
				FF_EnableControl "Konfigurator", "|||Einlesen", True
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FF-Version", FFVersion
			Case "|||Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuell in FF hinterlegten FTP-Konfigurationen tatschlich durch die gespeicherten Konfigurationsdaten ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					Aufruf = "regedit.exe /s " &  Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\ftp1.reg" & Chr(34)
					REM MsgBox Aufruf
					oWSHShell.Run Aufruf
					FTPDPath = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPDPath")
					FTPPath = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPPath")
					FTPPwd = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPPwd")
					FTPServer = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPServer") 
					FTPUser = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "FTPUser")
					PassiveFTP = ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "PassiveFTP")
					UseForumFTP =  ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "FTP-Daten", "UseForumFTP")
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPDPath", FTPDPath
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPPath", FTPPath
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPPwd", FTPPwd
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPServer", FTPServer
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\FTPUser", FTPUser
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\PassiveFTP", PassiveFTP
					oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\UseForumFTP", UseForumFTP
				End If
			' ** Ansichten lschen
			Case "ansicht_del_button"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Soll der Eintrag wirklich gelscht werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					delansicht = "Software\Joachim Koopmann Software\FixFoto\SaveState\" & FF_GetControl("Konfigurator","ansichten_combo") 
					DeleteKey &H80000001, delansicht
					FF_SetControl "Konfigurator","ansichten_combo", ""
					Call Ansichtenauslesen
				End If
			' ** Dialog-Zusammenstellungen
			Case "||||Sichern"
				Call INISectionExport (FF_GetFFPathEx(1) & "\FixFoto.ini", "[UserDlg0]", FF_GetFFPathEx(2) & "\Konfigurator\UserDlg0.txt")
				Call INISectionExport (FF_GetFFPathEx(1) & "\FixFoto.ini", "[StereoDlg0]", FF_GetFFPathEx(2) & "\Konfigurator\StereoDlg0.txt")
				Call INISectionExport (FF_GetFFPathEx(1) & "\FixFoto.ini", "[RetuDlg0]", FF_GetFFPathEx(2) & "\Konfigurator\RetuDlg0.txt")
				FF_SetControl "Konfigurator","diazusave", Date
				FF_SetControl "Konfigurator","ffvers_diazu_stat", FFVersion
				FF_EnableControl "Konfigurator", "||||Einlesen", True
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialogzusammenstellungen", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Dialogzusammenstellungen", "FF-Version", FFVersion
			Case "||||Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuell in FF hinterlegten Dialog-Zusammenstellungen (Benutzerdialog, Stereodialog, Retuschedialog) tatschlich durch die gespeicherten Zusammenstellungen ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					' bisherigen Eintrge aus der fixfoto.ini lschen
					Call INISectionDelet (FF_GetFFPathEx(1) & "\FixFoto.ini", "[UserDlg0]")
					Call INISectionDelet (FF_GetFFPathEx(1) & "\FixFoto.ini", "[StereoDlg0]")
					Call INISectionDelet (FF_GetFFPathEx(1) & "\FixFoto.ini", "[RetuDlg0]")
					' gespeicherten Eintrge in fixfoto.ini bernehmen
					Call INISectionImport (FF_GetFFPathEx(1) & "\FixFoto.ini", FF_GetFFPathEx(2) & "\Konfigurator\UserDlg0.txt")
					Call INISectionImport (FF_GetFFPathEx(1) & "\FixFoto.ini", FF_GetFFPathEx(2) & "\Konfigurator\StereoDlg0.txt")
					Call INISectionImport (FF_GetFFPathEx(1) & "\FixFoto.ini", FF_GetFFPathEx(2) & "\Konfigurator\RetuDlg0.txt")
				End If
			' *** Tastenbelegung ***
			Case "|||||Sichern"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Fr den Export der Tastaturbelegung muss FixFoto automatisch beendet werden. Danach wieder FixFoto automatisch neu gestartet." & vbNewLine & "Fortsetzen?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					FF_SetControl "Konfigurator","tastensave", Date
					FF_SetControl "Konfigurator","ff_vers_tast", FFVersion
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Tastaturkuerzel", "Speicherdatum", Date
					WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Tastaturkuerzel", "FF-Version", FFVersion
					Aufruf = Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\export_kuerzel.exe" & Chr(34)
					'msgbox aufruf
					oWSHShell.Run Aufruf,, False		' False = Skript wird sofort fortgesetzt
					Exit Sub							' explizit schlieen, um offene FF-Instanz zu vermeiden							
				End If
			Case "|||||Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuelle Tastaturbelegung tatschlich um die gespeicherten Tastaturkrzel ergnzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					Aufruf = Chr(34) & FF_GetFFPathEx(2) & "\Konfigurator\import_kuerzel.exe" & Chr(34)
					oWSHShell.Run Aufruf,, False		' False = Skript wird sofort fortgesetzt
					Exit Sub							' explizit schlieen, um offene FF-Instanz zu vermeiden
				End If
			'*** Skript-Schnelltasten ***
			Case "|||||||Sichern"
				stastzaehler = 0
				STastenarray = RegSubValues (&H80000001, "Software\Joachim Koopmann Software\FixFoto\Options")
				For i = 0 to UBound(STastenarray)
					if InStr(STastenarray(i,0), "ScriptKey") Then
						WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", STastenarray(i,0), oWSHShell.RegRead ("HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\" & STastenarray(i,0))
						stastzaehler = stastzaehler +1
					End If
				Next
				FF_SetControl "Konfigurator","stastensave", Date
				FF_SetControl "Konfigurator","ff_vers_stasten", FFVersion
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "FF-Version", FFVersion
				FF_EnableControl "Konfigurator", "|||||||Einlesen", True
				MsgBox "Es wurden " & stastzaehler & " Tastenkombinationen zum Aufruf von Skripten gesichert." 
			Case "|||||||Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuellen Tastaturkrzel fr Skripte tatschlich durch die gespeicherten Tastaturkrzel ergnzt bzw. aktualisiert werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					stastzaehler = 0
					for i = 1 to 9				' es gibt 9 mgliche Tastenbelegungen
						If ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "ScriptKey" & i) <> "" Then
							oWSHShell.RegWrite "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Options\" & "ScriptKey" & i, ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Skripttasten", "ScriptKey" & i)
							stastzaehler = stastzaehler + 1
						End If
					Next
					Msgbox "Es wurden " & stastzaehler & " Tastenkombinationen zum Aufruf von Skripten eingelesen."
				End If
			'*** Externe Programme-Parameter ***
			Case "||||||Sichern"
				Call INISectionExport (FF_GetFFPathEx(1) & "\FixFoto.ini", "[ExtProg]", FF_GetFFPathEx(2) & "\Konfigurator\ExtProg.txt")
				FF_SetControl "Konfigurator","extpsave", Date
				FF_SetControl "Konfigurator","ff_vers_exp", FFVersion
				FF_EnableControl "Konfigurator", "||||||Einlesen", True
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "ExtProg", "Speicherdatum", Date
				WriteIni FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "ExtProg", "FF-Version", FFVersion
			Case "||||||Einlesen"
				doit = 1
				If FF_GetControl ("Konfigurator","abfrag_bool") = "1" Then
					If MsgBox ("Sollen die aktuell in FF eingerichteten Aufrufe zu externen Programmen tatschlich durch die gespeicherten Aufrufe ersetzt werden?", 36, "Sicherheitsabfrage") = 7 Then doit = 0
				End If
				If doit = 1 Then
					Call INISectionDelet (FF_GetFFPathEx(1) & "\FixFoto.ini", "[ExtProg]")
					Call INISectionImport (FF_GetFFPathEx(1) & "\FixFoto.ini", FF_GetFFPathEx(2) & "\Konfigurator\ExtProg.txt")
				End If
			' *** Tooltipp in der Computeransicht
			Case "Tooltipp in der Computeransicht"
				If Version_equal_or_better("3.30.00") Then 			' Tooltipps erst ab 3.30 konfigurierbar
					Call Tippedit
				Else
					MsgBox "Die Tooltipps in der Computeransicht sind erst ab FF-Version 3.30 frei konfigurierbar.", 64, "Hinweis"
				End If
			'*** ZIP-Export *** 
			Case "Daten && Skript in eine ZIP"
				backuppfad = FF_EnterPath (True, "Speicherort auswhlen")
				If backuppfad <> "" Then
					backuppfad = backuppfad & "\konfigurator_daten.zip"
					Call FF_ZipWithFolder (FF_GetFFPathEx(2) & "\Konfigurator", backuppfad)
					MsgBox "Das Skript Konfigurator und alle gesicherten Daten wurden in das Archiv " & backuppfad & " gepackt." & vbNewLine & vbNewLine & "Das Archiv kann in FixFoto ber Datei -> Importieren -> Skript importieren wieder bernommen werden - z.B. nach einer Neuinstalation oder auf einem anderen Computer.", 64
				End If
			Case "?"
				Call Help				
			Case "Beenden", "CANCEL"
				Call DropboxKopie
				Exit Sub
		End Select
	Loop
End Sub

Sub INIauslesenBelichter
	Set f = fso.OpenTextFile(FF_GetFFPathEx(1) & "\FixFoto.ini", ForReading)
	inifeld = Split(f.ReadAll, vbNewLine)
	For i = 0 to UBound(inifeld)
		Call InhalttestBelichter
	Next
	
	for u = 0 to pfeldzeiger - 1
		FF_SetControl "Konfigurator","belichter_combo", PFeld(u, 0)
	Next
End Sub

Sub InhalttestBelichter
	if InStr(inifeld(i), "[Provider]") and pa = 0 Then
		PFeld(pfeldzeiger, 1) = i						' Anfang Providerberreich
		PFeld(pfeldzeiger, 0) = Mid(inifeld(i+1),6) 	' Name des Belichters
		pa = 1											' es wird gerade ein Belichter durchsucht
		Exit Sub
	End If
	if pa = 1 Then
		if InStr(inifeld(i), "[") or inifeld(i) = "" or i = UBound(inifeld) Then			' Ende Providerbereich
			PFeld(pfeldzeiger, 2) = i - 1
			pfeldzeiger = pfeldzeiger + 1
			pa = 0
			i = i - 1				' selbe Zeile soll erneut durchlaufen werden, falls sofort der nchste Provider beginnt 
		End If
	End If	
End Sub

Sub INIschreiben
	Set f = fso.OpenTextFile(FF_GetFFPathEx(1) & "\FixFoto.ini", ForWriting)
	for i = 0 to UBound(inifeld)
		if inifeld(i) <> "" Then f.WriteLine inifeld(i)
	Next
End Sub

Sub INISectionExport (inifile, section, exportfile)
	' kopiert eine INI-Section mit allen Untereintrgen in eine Datei
	Const ForReading = 1, ForWriting = 2
	Dim fso, f1, f2
	Dim saveline, iniarray, i
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set f1 = fso.OpenTextFile(inifile, ForReading)
	If fso.FileExists(exportfile) Then
		Set f2 = fso.OpenTextFile(exportfile, ForWriting)
	Else
		fso.CreateTextFile exportfile, True
		Set f2 = fso.OpenTextFile(exportfile, ForWriting)
	End If
	iniarray = Split(f1.ReadAll, vbNewLine)
	saveline = 0
	For i = 0 to UBound(iniarray)
		If InStr(iniarray(i), section) Then saveline = 1									' Sektion beginnt
		If InStr(iniarray(i), "[") and Not InStr(iniarray(i), section) Then	saveline = 0	' Sektion endet
		If saveline = 1 Then
			f2.WriteLine iniarray(i)
		End If
	Next
	f1.Close
	f2.Close
	Set f1 = Nothing
	Set f2 = Nothing
End Sub

Sub INISectionImport (inifile, importfile)
	' importiert eine INI-Section aus eine Datei
	Const ForReading = 1, ForAppending = 8
	Dim fso, f1, f2
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set f1 = fso.OpenTextFile(inifile, ForAppending)
	Set f2 = fso.OpenTextFile(importfile, ForReading)
	Do While f2.AtEndOfStream <> True
		f1.WriteLine f2.ReadLine
	Loop
	f1.Close
	f2.Close
	Set f1 = Nothing
	Set f2 = Nothing
End Sub

Sub INISectionDelet (inifile, section)
	' lscht eine INI-Section mit allen Untereintrgen
	Const ForReading = 1, ForWriting = 2
	Dim fso, f1
	Dim delline, iniarray, i
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set f1 = fso.OpenTextFile(inifile, ForReading)
	iniarray = Split(f1.ReadAll, vbNewLine)
	For i = 0 to UBound(iniarray)
		If InStr(iniarray(i), section) Then delline = 1									' Sektion beginnt
		If InStr(iniarray(i), "[") and Not InStr(iniarray(i), section) Then	delline = 0	' Sektion endet
		If delline = 1 Then
			iniarray(i) = "##delline**"
		End If
	Next
	Set f1 = fso.OpenTextFile(inifile, ForWriting)
	For i = 0 to UBound(iniarray)
		If iniarray(i) <> "##delline**" Then
			f1.WriteLine iniarray(i)
		End If
	Next
	f1.Close
	Set f1 = Nothing
End Sub

Sub Makroauslesen
	On Error Resume Next	'falls die INI nicht vorhanden ist
	Set f = fso.OpenTextFile(FF_GetFFPathEx(1) & "\Batch\Macros.ini", ForReading)
	makrofeld = Split(f.ReadAll, vbNewLine)
	For u = 0 to UBound(makrofeld) -1
		If InStr(makrofeld(u), "Name=") Then
			FF_SetControl "Konfigurator","makro_combo", Mid(makrofeld(u),6)
		End If
	Next
	On Error Goto 0
End Sub

Sub Stapelauslesen
	stapelfeld = ReadAllFiles (FF_GetFFPathEx(1) & "\Batch\", "*.fbi", False)
	for u = 0 to ubound(stapelfeld) 
		FF_SetControl "Konfigurator","stapel_combo", fso.GetBaseName(stapelfeld(u))		' nur Datename ohne Endung in die Combo
	Next
End Sub

Sub Seitenauslesen
	seitenfeld = ReadAllFiles (FF_GetFFPathEx(6) & "\", "*.ini", False)
	for u = 0 to ubound(seitenfeld) 
		FF_SetControl "Konfigurator","seiten_combo", fso.GetBaseName(seitenfeld(u))		' nur Datename ohne Endung in die Combo
	Next
End Sub

Sub Obkorauslesen		' Daten fr Objektkorrektur (*.ff) ermitteln
	obkorfeld = ReadAllFiles (FF_GetFFPathEx(1) & "\", "*.ff", False)
	for u = 0 to ubound(obkorfeld) 
		FF_SetControl "Konfigurator","obkor_combo", fso.GetBaseName(obkorfeld(u))		' nur Datename ohne Endung in die Combo
	Next
End Sub

Sub Farbkorauslesen		' Daten ein fr Farbkorrektur (*.cff) ermitteln
	farbkorfeld = ReadAllFiles (FF_GetFFPathEx(1) & "\", "*.cff", False)
	for u = 0 to ubound(farbkorfeld) 
		FF_SetControl "Konfigurator","farbkor_combo", fso.GetBaseName(farbkorfeld(u))		' nur Datename ohne Endung in die Combo
	Next
End Sub

Sub Ansichtenauslesen		' fr Ansichten-Lschfunktion und Tooltip (Inhalt der Speicherung) 
	Dim Ansichtenarray
	Ansichtenarray = RegSubKeys (&H80000001, "Software\Joachim Koopmann Software\FixFoto\SaveState")
	REM FF_SetControl "Konfigurator","ansichten_combo",""
	Tooltiptext = "gespeicherte Ansichten_______________________________"
	On Error Resume Next	' Fehler abfangen, wenn es keine Ansichten gibt
	For i = 0 to UBound(Ansichtenarray)
		FF_SetControl "Konfigurator","ansichten_combo", Ansichtenarray(i)
		Tooltiptext = Tooltiptext & Ansichtenarray(i) & ""
	next
	On Error Goto 0
End Sub

Function FFVersion
	FFVersion =  "(" & FF_GetMajor & "." & FF_GetMinor & " build " & FF_GetBuild & ")"
End Function

Function Version_equal_or_better(p_Vers)
	Dim l_VersNr
	l_VersNr=split(p_Vers,".")
	version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000 >= l_VersNr(0)*1000+l_VersNr(1)+l_VersNr(2)/1000)
End Function

'### einlesen Verzeichnis ###

'Liest alle Dateien ein, die den Kriterien entsprechen
'Parameter:
'sPath: Vollstndiger Ursprungspfad
'sFilter: Dateifilter. Zugelassene Filterzeichen: "*". Mehrere Filter werden mit Semikolon ";" getrennt
'bRecursive: True = Durchsucht auch Unterverzeichnisse
Public Function ReadAllFiles(sPath, sFilter, bRecursive)
 Dim oFolderClass
 Set oFolderClass = New clsFolder
 With oFolderClass
 .FileFilter = sFilter
 ReadAllFiles = .GetFiles(sPath, bRecursive)
 End With
 Set oFolderClass = Nothing
End Function
 
'::::::::::::::::::::::::::::::::::::::::::
Class clsFolder
'::::::::::::::::::::::::::::::::::::::::::
 Private mv_fso
 Private mv_Filter
 Public FileTypes
 
 Private Sub Class_Initialize()
 Set mv_fso = CreateObject("Scripting.FileSystemObject")
 mv_Filter = Array("*.*")
 End Sub
 Private Sub Class_Terminate()
 Set mv_fso = Nothing
 Erase mv_Filter
 End Sub
 
 ' Eigenschaft: Filter
 ' Zulssige Filterzeichen: *
 ' Mehrere Definitionen werden mit Semikolon ";" getrennt
 Public Property Let FileFilter(ByVal sValue)
 Dim i
 
 If Len(sValue) = 0 Then
 mv_Filter = Array("*.*")
 Else
 mv_Filter = Split(Trim(sValue), ";")
 For i = 0 To UBound(mv_Filter, 1)
 mv_Filter(i) = Trim(mv_Filter(i))
 Next
 End If
 End Property
 Public Property Get FileFilter()
 FileFilter = Join(mv_Filter, ";")
 End Property
 
 'Testet Dateinamen, ob sie dem Dateifilter entsprechen
 Public Function TestFilter(sFilePath)
 Dim sName
 Dim aSplit
 Dim i
 Dim lUBound
 Dim lPos
 Dim sFilter
 
 Dim bStartFilter
 
 TestFilter = False
 
 sName = mv_fso.GetFileName(sFilePath)
 
 For Each sFilter In mv_Filter
 If Len(sFilter) > 0 Then
 aSplit = Split(sFilter, "*")
 lUBound = UBound(aSplit, 1)
 lPos = 1
 For i = 0 To lUBound
 Select Case True
 Case CBool((i = 0) And (Len(aSplit(0)) = 0))
 Case CBool((i = lUBound) And (Len(aSplit(lUBound)) = 0))
 TestFilter = True
 Exit Function
 Case Len(aSplit(i)) = 0
 Case Else
 lPos = InStr(lPos, sName, aSplit(i), vbTextCompare)
 If CBool((i = 0) And (lPos <> 1)) Then Exit For
 If lPos = 0 Then Exit For
 
 lPos = lPos + Len(aSplit(i))
 End Select
 Next
 If lPos >= Len(sName) Then
 TestFilter = True
 Exit Function
 End If
 End If
 Next
 End Function
 
 ' Holt alle Dateien aus dem angegebenen Verzeichnis
 ' Parameter:
 ' sPath: Vollstndiger Verzeichnispfad
 ' bRecursive: Gibt an, dass auch Unterverzeichnisse des Pfades durchsucht werden sollen
 Public Function GetFiles(ByVal sPath, ByVal bRecursive)
 Dim aFiles
 aFiles = Array()
 If Not mv_fso.FolderExists(sPath) Then
 GetFiles = aFiles
 Exit Function
 End If
 
 RecGetFiles sPath, bRecursive, aFiles
 
 GetFiles = aFiles
 End Function
 
 'Hilfsmethode zur rekursiven Durchsuchung
 Private Sub RecGetFiles(ByRef sPath, ByVal bRecursive, ByRef aFiles)
 Dim oFolder
 Dim oSubFolder
 Dim oFile
 Set oFolder = mv_fso.GetFolder(sPath)
 
 For Each oFile in oFolder.Files
 If TestFilter(oFile.Path) Then
 ReDim Preserve aFiles(UBound(aFiles, 1) + 1)
 aFiles(UBound(aFiles, 1)) = oFile.Path
 End If
 Next
 If bRecursive Then
 For Each oSubFolder in oFolder.SubFolders
 RecGetFiles oSubFolder.Path, bRecursive, aFiles
 Next
 End If
 End Sub
 
'::::::::::::::::::::::::::::::::::::::::::
End Class
'::::::::::::::::::::::::::::::::::::::::::

Function ReadIni( myFilePath, mySection, myKey )
    ' www.robvanderwoude.com/vbstech_files_ini.php
    ' This function returns a value read from an INI file
    '
    ' Arguments:
    ' myFilePath  [string]  the (path and) file name of the INI file
    ' mySection   [string]  the section in the INI file to be searched
    ' myKey       [string]  the key whose value is to be returned
    '
    ' Returns:
    ' the [string] value for the specified key in the specified section
    '
    ' CAVEAT:     Will return a space if key exists but value is blank
    '
    ' Written by Keith Lacelle
    ' Modified by Denis St-Pierre and Rob van der Woude

    Const ForReading   = 1
    Const ForWriting   = 2
    Const ForAppending = 8
 
    Dim intEqualPos
    Dim objFSO, objIniFile
    Dim strFilePath, strKey, strLeftString, strLine, strSection
 
    Set objFSO = CreateObject( "Scripting.FileSystemObject" )
 
    ReadIni     = ""
    strFilePath = Trim( myFilePath )
    strSection  = Trim( mySection )
    strKey      = Trim( myKey )
 
    If objFSO.FileExists( strFilePath ) Then
        Set objIniFile = objFSO.OpenTextFile( strFilePath, ForReading, False )
        Do While objIniFile.AtEndOfStream = False
            strLine = Trim( objIniFile.ReadLine )
 
            ' Check if section is found in the current line
            If LCase( strLine ) = "[" & LCase( strSection ) & "]" Then
                strLine = Trim( objIniFile.ReadLine )
 
                ' Parse lines until the next section is reached
                Do While Left( strLine, 1 ) <> "["
                    ' Find position of equal sign in the line
                    intEqualPos = InStr( 1, strLine, "=", 1 )
                    If intEqualPos > 0 Then
                        strLeftString = Trim( Left( strLine, intEqualPos - 1 ) )
                        ' Check if item is found in the current line
                        If LCase( strLeftString ) = LCase( strKey ) Then
                            ReadIni = Trim( Mid( strLine, intEqualPos + 1 ) )
                            ' In case the item exists but value is blank
                            If ReadIni = "" Then
                                ReadIni = " "
                            End If
                            ' Abort loop when item is found
                            Exit Do
                        End If
                    End If
 
                    ' Abort if the end of the INI file is reached
                    If objIniFile.AtEndOfStream Then Exit Do
 
                    ' Continue with next line
                    strLine = Trim( objIniFile.ReadLine )
                Loop
            Exit Do
            End If
        Loop
        objIniFile.Close
     End If
End Function

Sub WriteIni( myFilePath, mySection, myKey, myValue )
    ' http://www.robvanderwoude.com/vbstech_files_ini.php
    ' This subroutine writes a value to an INI file
    '
    ' Arguments:
    ' myFilePath  [string]  the (path and) file name of the INI file
    ' mySection   [string]  the section in the INI file to be searched
    ' myKey       [string]  the key whose value is to be written
    ' myValue     [string]  the value to be written (myKey will be
    '                       deleted if myValue is <DELETE_THIS_VALUE>)
    '
    ' Returns:
    ' N/A
    '
    ' CAVEAT:     WriteIni function needs ReadIni function to run
    '
    'To delete a key in an INI file, use WriteINI with a value "<DELETE_THIS_VALUE>".
    '
    ' Written by Keith Lacelle
    ' Modified by Denis St-Pierre, Johan Pol and Rob van der Woude

    Const ForReading   = 1
    Const ForWriting   = 2
    Const ForAppending = 8
 
    Dim blnInSection, blnKeyExists, blnSectionExists, blnWritten
    Dim intEqualPos
    Dim objFSO, objNewIni, objOrgIni, wshShell
    Dim strFilePath, strFolderPath, strKey, strLeftString
    Dim strLine, strSection, strTempDir, strTempFile, strValue
 
    strFilePath = Trim( myFilePath )
    strSection  = Trim( mySection )
    strKey      = Trim( myKey )
    strValue    = Trim( myValue )
 
    Set objFSO   = CreateObject( "Scripting.FileSystemObject" )
    Set wshShell = CreateObject( "WScript.Shell" )
 
    strTempDir  = wshShell.ExpandEnvironmentStrings( "%TEMP%" )
    strTempFile = objFSO.BuildPath( strTempDir, objFSO.GetTempName )
 
    Set objOrgIni = objFSO.OpenTextFile( strFilePath, ForReading, True )
    Set objNewIni = objFSO.CreateTextFile( strTempFile, False, False )
 
    blnInSection     = False
    blnSectionExists = False
    ' Check if the specified key already exists
    blnKeyExists     = ( ReadIni( strFilePath, strSection, strKey ) <> "" )
    blnWritten       = False
 
    ' Check if path to INI file exists, quit if not
    strFolderPath = Mid( strFilePath, 1, InStrRev( strFilePath, "\" ) )
    If Not objFSO.FolderExists ( strFolderPath ) Then
        WScript.Echo "Error: WriteIni failed, folder path (" _
                   & strFolderPath & ") to ini file " _
                   & strFilePath & " not found!"
        Set objOrgIni = Nothing
        Set objNewIni = Nothing
        Set objFSO    = Nothing
        WScript.Quit 1
    End If
 
    While objOrgIni.AtEndOfStream = False
        strLine = Trim( objOrgIni.ReadLine )
        If blnWritten = False Then
            If LCase( strLine ) = "[" & LCase( strSection ) & "]" Then
                blnSectionExists = True
                blnInSection = True
            ElseIf InStr( strLine, "[" ) = 1 Then
                blnInSection = False
            End If
        End If
 
        If blnInSection Then
            If blnKeyExists Then
                intEqualPos = InStr( 1, strLine, "=", vbTextCompare )
                If intEqualPos > 0 Then
                    strLeftString = Trim( Left( strLine, intEqualPos - 1 ) )
                    If LCase( strLeftString ) = LCase( strKey ) Then
                        ' Only write the key if the value isn't empty
                        ' Modification by Johan Pol
                        If strValue <> "<DELETE_THIS_VALUE>" Then
                            objNewIni.WriteLine strKey & "=" & strValue
                        End If
                        blnWritten   = True
                        blnInSection = False
                    End If
                End If
                If Not blnWritten Then
                    objNewIni.WriteLine strLine
                End If
            Else
                objNewIni.WriteLine strLine
                    ' Only write the key if the value isn't empty
                    ' Modification by Johan Pol
                    If strValue <> "<DELETE_THIS_VALUE>" Then
                        objNewIni.WriteLine strKey & "=" & strValue
                    End If
                blnWritten   = True
                blnInSection = False
            End If
        Else
            objNewIni.WriteLine strLine
        End If
    Wend
 
    If blnSectionExists = False Then ' section doesn't exist
        objNewIni.WriteLine
        objNewIni.WriteLine "[" & strSection & "]"
            ' Only write the key if the value isn't empty
            ' Modification by Johan Pol
            If strValue <> "<DELETE_THIS_VALUE>" Then
                objNewIni.WriteLine strKey & "=" & strValue
            End If
    End If
 
    objOrgIni.Close
    objNewIni.Close
 
    ' Delete old INI file
    objFSO.DeleteFile strFilePath, True
    ' Rename new INI file
    objFSO.MoveFile strTempFile, strFilePath
 
    Set objOrgIni = Nothing
    Set objNewIni = Nothing
    Set objFSO    = Nothing
    Set wshShell  = Nothing
End Sub

 Function RegSubKeys (Rootkey, SubPath)
	' liefert ein Array mit allen Unterknoten zu einem Registrypfad
	' Rootkey bezeichnet den RootKey 
		' HKEY_CLASSES_ROOT 	= &H80000000
		' HKEY_CURRENT_USER 	= &H80000001
		' HKEY_LOCAL_MACHINE 	= &H80000002
		' HKEY_USERS 			= &H80000003
		' HKEY_CURRENT_CONFIG 	= &H80000005
	' Subpath bezeichnet den weiteren Pfad
		' Bsp.: Software\Joachim Koopmann Software\FixFoto 
	Dim objReg
	Dim arrSubKeys, strSubKey, strKeys
	Set objReg = GetObject("winmgmts://./root/default:StdRegProv")
	objReg.EnumKey Rootkey, SubPath, arrSubKeys 
	RegSubKeys = arrSubKeys
	Set objReg = Nothing 
 End Function
 
 Function RegSubValues (Rootkey, SubPath)
	' liefert ein Array mit allen Schlsseln zu einem Registrypfad 
	' und dem Typ des jeweiligen Schlssels
	' Rootkey bezeichnet den RootKey
	' 	HKEY_CLASSES_ROOT     = &H80000000
	' 	HKEY_CURRENT_USER     = &H80000001
	' 	HKEY_LOCAL_MACHINE    = &H80000002
	' 	HKEY_USERS            = &H80000003
	' 	HKEY_CURRENT_CONFIG   = &H80000005
	' Subpath bezeichnet den weiteren Pfad
	' 	Bsp.: Software\Joachim Koopmann Software\Text
	Dim oReg
	Dim arrValueNames, arrValueTypes
	Dim i, sammelarr()
	Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
	oReg.EnumValues Rootkey, SubPath, arrValueNames, arrValueTypes
	ReDim sammelarr (UBound(arrValueNames),1) 
	For i=0 To UBound(arrValueNames)
		sammelarr(i,0) = arrValueNames(I)
		Select Case arrValueTypes(I)
			Case 1	sammelarr(i,1) = "String"
			Case 2	sammelarr(i,1) = "Expanded String"
			Case 3	sammelarr(i,1) = "Binary"
			Case 4	sammelarr(i,1) = "DWORD"
			Case 7	sammelarr(i,1) = "Multi String"
		End Select 
	Next
	RegSubValues = sammelarr
	Set oReg = Nothing
End Function
 
 Sub DeleteKey(Rootkey, KeyPath)
	 ' Zweige in der Registry lschen, einschlielich aller Unterzweige
	 ' Autor: Thomas@Gartner-IT.net
	 ' http://www.it-visions.de/foren/display_message.asp?mid=568
	 ' verwendet: WMI
	 ' Rootkey bezeichnet den RootKey
		 ' HKEY_CLASSES_ROOT = &H80000000 
		 ' HKEY_CURRENT_USER = &H80000001 
		 ' HKEY_LOCAL_MACHINE = &H80000002
		 ' HKEY_USERS = &H80000003
		 ' HKEY_CURRENT_CONFIG = &H80000005
		 ' HKEY_DYN_DATA = &H80000006
	' KeyPath bezeichnet den zu lschenden Zweig
		' z.B. "Software\Joachim Koopmann Software\FixFoto\SaveState\Ansicht2"
	 Dim objReg
	 Set objReg = GetObject("winmgmts:\\.\root\default:StdRegProv")
	 Dim ValueArray, Value
	 ' Unterschlssel auflisten
	 objReg.EnumKey Rootkey, KeyPath, ValueArray
	 If Not IsNull(ValueArray) Then 
		 For Each Value In ValueArray
			' Rekursion starten
			DeleteKey Rootkey, KeyPath + "\" + Value
		 Next
	 End If
	 ' Schlssel lschen
	 objReg.DeleteKey Rootkey, KeyPath + "\" + Value
 End Sub

Sub FF_ZipWithFolder (sourcefolder, target)
	' erzeugt ZIP-Archiv unter Einschluss der obersten Ordnerebene
	' im TEMP-Verzeichnis wird dazu ein temp. Struktur aufgebaut
	' praetor 16.12.2011
	Dim fso
	Dim oFolder
	Dim sTempPath

	Set fso = CreateObject("Scripting.FileSystemObject")
	sTempPath = fso.GetSpecialFolder(2)					' TEMP-Verzeichnis ermitteln
	If fso.FolderExists (sTempPath & "\FFKonfiTemp\") Then	' Arbeitsordner sicherheitshalber ggf. lschen
		fso.DeleteFolder (sTempPath & "\FFKonfiTemp"), True
	End If
	fso.CreateFolder (sTempPath & "\FFKonfiTemp\")		' Arbeitsordner im TEMP-Verzeichnis erstellen
	Set oFolder = fso.GetFolder(sourcefolder)		
	oFolder.Copy (sTempPath & "\FFKonfiTemp\")			' zu packenden Orner in Arbeitsordner kopieren
	FF_Zip sTempPath & "\FFKonfiTemp", target			' Archiv am Zielort erstellen
	fso.DeleteFolder (sTempPath & "\FFKonfiTemp"), True	' Arbeitsordner wieder lschen
	Set oFolder = Nothing
	Set fso = Nothing
 End Sub
 
 Sub DropboxKopie		' Skript und alle gespeicherten Daten in die Dropbox kopieren
	If FF_GetControl("Konfigurator","dropbox_bool") = 1 Then
		DBPfad = DropBoxPfad & "\"	' Ermittlung ber Funktion DropBoxPfad
		REM On Error Resume Next
		If Len(DBPfad) > 0 Then
			If Not fso.FolderExists(DBPfad & "Konfigurator\") Then		' bei Bedarf Ordner anlegen
				fso.CreateFolder(DBPfad & "Konfigurator\")
			End If			
			aktdatum = Right(Year(Now),2) & Right("0" & Month(Now), 2) & Right("0" & Day(Now), 2)	' Tagesdtum im Format yymmdd
			If Not fso.FolderExists(DBPfad & "Konfigurator\" & aktdatum & "\") Then			' bei Bedarf Ordner anlegen
				fso.CreateFolder(DBPfad & "Konfigurator\" & aktdatum & "\")
			End If
			fso.CopyFile FF_GetFFPathEx(2) & "\Konfigurator\*.*", DBPfad & "Konfigurator\"	& aktdatum & "\" ' alles Kopieren mit berschreiben
			MsgBox "Eine Kopie des Skripts und alle gespeicherten Daten wurde im Dropbox-Ordner" & vbNewLine & "   " & DBPfad & vbNewLine & "im Verzeichnis" & vbNewLine & "   " &"\Konfigurator\" & aktdatum & "\" & vbNewLine & "angelegt.", 64, "Daten und Skript zur Dropbox"
		Else
			MsgBox "Eine Kopie in der Dropbox kann nicht erzeugt werden." 
			REM & vbNewLine & vbNewLine & "Es wurde noch kein lokaler Dropbox-Ordner festgelegt (zu Beginn der Skriptdatei 'konfigurator.vbs').", 48, "Daten und Skript zur Dropbox"
		End If
		if Err.Number > 0 Then
			MsgBox "Bei der bertragung der Daten in den Dropbox-Ordner ist ein Fehler aufgetreten.", 48, "Daten und Skript zur Dropbox"
		End If
		On Error Goto 0
	End If
 End Sub
 
 Function Is64Bit()
	 ' gibt True zurck, wenn FF in der 64 Bit-Version luft
	 ' basiert darauf, dass Xe847 unter 64 Bit nicht verfgbar ist
	 ' Idee: Niels1938
	Dim test
	test = "a"
	FF_NewImage 2, 2, 65535		' Bild erzeugen, damit XE847 fehlerfrei luft obwohl Arbeitsflche ggf. leer ist
	On Error Resume Next		' Fehler unter 64 Bit abfangen
	test = FF_Xe847(1)
	On Error Goto 0
	If test = "a" then 
		Is64Bit = True			' FF 64 Bit
	Else
		Is64Bit = False			' FF 32 Bit
	End If
End Function

Sub Tippedit
	const Platzhalter = "Anzahl der Pixel\$$PX$$\Bildbreite\$$WIDTH$$\Bildhhe\$$HEIGHT$$\Dateiendung\$$EXT$$\Dateigre\$$FSIZE$$\Dateiname\$$NAME$$\Dateiname ohne Endung\$$NAMEONLY$$\Dateipfad\$$PATH$$\Aufnahmezeitpunkt\$$DATETIMEORIGINAL$$\Datum und Zeit\$$DATE$$\Digitalisierung und Speicherung der Aufnahme\$$DATETIMEDIGITIZED$$\Jahr\$$YEAR$$\Jahr (2-stellig)\$$YE2$$\Monat (Name)\$$NMO$$\Monat (Zahl)\$$MONTH$$\Tag (Zahl)\$$DAY$$\Stunde\$$HOUR$$\Minute\$$MINUTE$$\Sekunde\$$SECOND$$\Belichtungskorrektur\$$EV$$\Belichtungsmessmethode\$$METERINGMODE$$\Belichtungsprogramm\$$EXPOSUREPROGRAM$$\Belichtungszeit\$$EXPOSURETIME$$\Beschreibung\$$IMAGEDESCRIPTION$$\Bildlage\$$ORIENTATION$$\Blende\$$FNUMBER$$\Blendenwert\$$APERTUREVALUE$$\Blitz\$$FLASH$$\Brennweite\$$FOCALLENGTH$$\Brennweite umgerechnet\$$FOCALLENGTHIN35MMFILM$$\Copyright 1\$$COPYRIGHT1$$\Copyright 2\$$COPYRIGHT2$$\Entfernung\$$SUBJECTDISTANCE$$\Fotograf\$$ARTIST$$\ISO\$$ISO$$\Kamera\$$CAMERA$$\Kommentar\$$USERCOMMENT$$\Lichtquelle\$$LIGHTSOURCE$$\Maximaler Blendenwert\$$MAXAPERTUREVALUE$$\Weiabgleich\$$WHITEBALANCE$$\Bildbewertung (Sterne)\$$RATING$$\Bildbewertung (Prozent)\$$RATINGPERCENT$$\Breitengrad\$$LATITUDE$$\GPS-Zeit\$$TIMESTAMP$$\Hhe\$$ALTITUDE$$\Kartenformat\$$MAPDATUM$$\Lngengrad\$$LONGITUDE$$\Satelliten\$$SATELLITES$$\Auftraggeber-Code\$$ORIGINALTRANSMISSIONREFERENCE$$\Autor\$$WRITER/EDITOR$$\Bearbeitungsstatus\$$EDITSTATUS$$\Besondere Hinweise\$$SPECIALINSTRUCTIONS$$\Bildrechte\$$CREDIT$$\Bundesland\$$PROVINCESTATE$$\Copyrightvermerk\$$COPYRIGHTNOTICE$$\Dringlichkeit\$$URGENCY$$\Kategorie\$$CATEGORY$$\Lndercode\$$COUNTRYCODE$$\Land\$$COUNTRY$$\Name des Autors\$$BYLINE$$\Name des Bildes\$$OBJECTNAME$$\Objektattribut\$$OBJECTATTRIBUTEREF$$\Objektbeschreibung\$$CAPTION/ABSTRACT$$\Quelle des Bildes\$$SOURCE$$\Referenznummer\$$SUBJECTREF$$\Schlagwrter\$$KEYWORDS$$\Stadt\$$CITY$$\Stadtteil\$$SUBLOCATION$$\Titel des Autors\$$BYLINETITLE$$\berschrift\$$HEADLINE$$\Zeichensatz\$$CHARACTERSET$$\Zusatzkategorien\$$SUPPLEMENTALCATEGORY$$"
	phfeld = Split(Platzhalter, "\") 
	'msgbox UBound(phfeld)
	
	Call Dialog_Tooltipp
	do					
		Select Case FF_ShowDialog("Tooltipp in der Computeransicht")
			Case "datei_combo"
				ttauswahl = FF_GetControl ("Tooltipp in der Computeransicht", "datei_combo")
				Call Auswahltextuebernehmen
			Case "datum_combo"
				ttauswahl = FF_GetControl ("Tooltipp in der Computeransicht", "datum_combo")
				Call Auswahltextuebernehmen
			Case "exif_combo"
				ttauswahl = FF_GetControl ("Tooltipp in der Computeransicht", "exif_combo")
				Call Auswahltextuebernehmen
			Case "gps_combo"
				ttauswahl = FF_GetControl ("Tooltipp in der Computeransicht", "gps_combo")
				Call Auswahltextuebernehmen
			Case "iptc_combo"
				ttauswahl = FF_GetControl ("Tooltipp in der Computeransicht", "iptc_combo")
				Call Auswahltextuebernehmen
			Case "Tab"
				ttauswahl = "\t"
				Call Auswahltextuebernehmen
			Case "Standard als Basis"
				standarttipptext = "Name\t$$NAME$$" & vbNewLine & "Dateigre\t$$FSIZE$$" & vbNewLine & "Bildgre\t$$WIDTH$$ x $$HEIGHT$$" & vbNewLine & "Datum\t$$DATE$$" & vbNewLine & "Einstellungen\t$$EXPOSURETIME$$, F$$FNUMBER$$, $$FOCALLENGTH$$mm, $$EV$$EV, ISO:$$ISO$$" & vbNewLine & vbNewLine & "$$IMAGEDESCRIPTION$$"
				FF_SetControl "Tooltipp in der Computeransicht", "fmt_edit", standarttipptext
			Case "Zurcksetzen auf Standard"
				if MsgBox ("Soll die Konfigurationsdatei fr den Tooltipp tatschlich gelscht werden?",36,"Zurcksetzen auf Standard") = 6 then
					' Prfe, ob es ToolTip.fmt gib, wenn ja: lschen
					If fso.FileExists(FF_GetFFPathEx(1) & "\ToolTip.fmt") Then
						fso.DeleteFile FF_GetFFPathEx(1) & "\ToolTip.fmt"
					End If
					FF_SetControl "Tooltipp in der Computeransicht", "fmt_edit", ""
				End If
			Case "Speichern u. Schlieen"
				Set ttdatei = fso.OpenTextFile(FF_GetFFPathEx(1) & "\ToolTip.fmt", ForWriting, True)
				ttdatei.Write FF_GetControl("Tooltipp in der Computeransicht", "fmt_edit")
				MsgBox "Genderter Tooltipp fr die Computeransicht wird erst nach Neustart von FixFoto wirksam.", 64, "Hinweis"
				FF_CloseDialog "Tooltipp in der Computeransicht"
				Exit Sub
			Case "Abbruch", "CANCEL"
				FF_CloseDialog "Tooltipp in der Computeransicht"
				Exit Sub
		End Select	
	Loop
End Sub

Sub Auswahltextuebernehmen
	If FF_GetAsyncKeyState(17) = False Then		' Strg wurden nicht gedrckt 
		for i = 0 to UBound(phfeld) step 2
			if phfeld(i) = ttauswahl Then
				ttauswahl = phfeld(i+1)
			End If
		Next
	End If
	Call InsertInTextBox ("Tooltipp in der Computeransicht", "fmt_edit", ttauswahl)
	FF_ActivateControl "Tooltipp in der Computeransicht", "fmt_edit"	
	oWSHShell.SendKeys("{LEFT}{RIGHT}")			' Hebt Markierung nach dem Einfgen auf
 End Sub

Sub Dialog_Tooltipp
	'** Start Dialog Tooltipp in der Computeransicht **
	FF_AddDialog "Tooltipp in der Computeransicht",305,147
	FF_AddControl "Tooltipp in der Computeransicht","IPTC","GROUP",4,107,81,22
	FF_AddControl "Tooltipp in der Computeransicht","GPS","GROUP",4,81,81,22
	FF_AddControl "Tooltipp in der Computeransicht","Exif","GROUP",4,55,81,22
	FF_AddControl "Tooltipp in der Computeransicht","Datum / Zeit","GROUP",4,29,81,22
	FF_AddControl "Tooltipp in der Computeransicht","Datei","GROUP",4,3,81,22
	FF_AddControl "Tooltipp in der Computeransicht","datei_combo","COMBO",9,11,70,10
	FF_AddControl "Tooltipp in der Computeransicht","datum_combo","COMBO",9,37,70,10
	FF_AddControl "Tooltipp in der Computeransicht","exif_combo","COMBO",9,63,70,10
	FF_AddControl "Tooltipp in der Computeransicht","gps_combo","COMBO",9,89,70,10
	FF_AddControl "Tooltipp in der Computeransicht","iptc_combo","COMBO",9,115,70,10
	FF_AddControl "Tooltipp in der Computeransicht","Tab","BUTTON",92,114,21,11
	FF_AddControl "Tooltipp in der Computeransicht","fmt_edit","EDIT",90,5,211,103
	FF_AddControl "Tooltipp in der Computeransicht","Speichern u. Schlieen","BUTTON",227,131,73,11
	FF_AddControl "Tooltipp in der Computeransicht","Abbruch","BUTTON",117,114,38,11
	FF_AddControl "Tooltipp in der Computeransicht","Auswahl mit <Strg> fgt die Beschreibung ein, sonst wird der Platzhalter eingefgt","STATIC",6,131,210,11
	FF_AddControl "Tooltipp in der Computeransicht","Zurcksetzen auf Standard","BUTTON",227,114,73,11
	FF_AddControl "Tooltipp in der Computeransicht","Standard als Basis","BUTTON",170,114,53,11
	'** End Dialog Tooltipp in der Computeransicht **
	For i = 0 to 14 step 2
		FF_SetControl "Tooltipp in der Computeransicht","datei_combo", phfeld(i)
	Next
	For i = 16 to 36 step 2
		FF_SetControl "Tooltipp in der Computeransicht","datum_combo", phfeld(i)
	Next
		For i = 38 to 82 step 2
		FF_SetControl "Tooltipp in der Computeransicht","exif_combo", phfeld(i)
	Next
		For i = 84 to 94 step 2
		FF_SetControl "Tooltipp in der Computeransicht","gps_combo", phfeld(i)
	Next
		For i = 96 to UBound(phfeld) step 2
		FF_SetControl "Tooltipp in der Computeransicht","iptc_combo", phfeld(i)
	Next
	If fso.FileExists(FF_GetFFPathEx(1) & "\ToolTip.fmt") Then
		Set ttdatei = fso.OpenTextFile(FF_GetFFPathEx(1) & "\ToolTip.fmt", ForReading)
		On Error Resume Next								' fngt Fehler bei leerer Datei ab
		FF_SetControl "Tooltipp in der Computeransicht", "fmt_edit", ttdatei.ReadAll
		On Error Goto 0
		ttdatei.Close
	End If
	If Version_equal_or_better("3.30.06") Then 			' Tooltipps erst ab 3.30 beta 6
		FF_SetControlTooltip "Tooltipp in der Computeransicht","Zurcksetzen auf Standard", "Tootip auf den FF-Standard zurcksetzen"
		FF_SetControlTooltip "Tooltipp in der Computeransicht","Standard als Basis", "Einstellungen wie der FF-Standard, kann dann weiter verndert werden" 
		FF_SetControlTooltip "Tooltipp in der Computeransicht","Tab", "fgt Steuerzeichen fr einen Tabulator ein"
	End If
End Sub

'Fgt Text in ein Textfeld an Cursorposition ein
Sub InsertInTextBox(sDlg, sControl, sText)
	Const EM_GETSEL = &H00B0
	Const EM_SETSEL = &H00B1
	Dim lPos
	Dim lSelStart
	Dim lSelEnd
	Dim sControlText
	
	lPos = CLng(FF_SendControl(sDlg, sControl, EM_GETSEL, 0, 0))
	lSelStart = lPos And &HFFFF&
	lSelEnd = (lPos \ &HFFFF&)
	sControlText = FF_GetControl(sDlg, sControl)
	FF_SetControl sDlg, sControl, Left(sControlText, lSelStart) & sText & Mid(sControlText, lSelEnd + 1)
End Sub	

Sub Help
	Dim ht
	ht = "Konfigurator - div. Einstellungen und Datensicherungen in FF" & vbNewLine
	ht = ht & "----------------------------------------------------------------" & vbNewLine & vbNewLine
	ht = ht & "Sinn und Zweck dieses Skripts sowie seine Bedienung sollten selbsterklrend sein." & vbNewLine & "Wo notwenig, geben Tooltips weitere Hinweise." & vbNewLine & vbNewLine
	ht = ht & "[Andreas Kleingnther 2012 / 2016]"
	msgbox ht, 64, "Konfigurator"
End Sub

Function DropBoxPfad
	' ermittelt den lokalen Pfad des DropBox-Ordners
	' kgsoft 160802
	Dim WshShell
	Dim fso
	Const ForReading = 1, ForWriting = 2
	Dim AppDataPfad
	Dim aktOrdner
	Dim DropInfo
	Dim f
	Dim DropInfoText
	' Systemordner Appdata ermitteln
	Set WshShell = CreateObject ("WScript.Shell")
	Set fso = CreateObject("Scripting.FileSystemObject")
	AppDataPfad = WshShell.Environment("Process")("APPDATA")
	aktOrdner = Right(AppDataPfad, Len (AppDataPfad) - InStrRev(AppDataPfad, "\",-1, 1))
	if aktOrdner <> "AppData" Then			' aktueller Ordner ist Roaming oder Local oder LocalLow
		AppDataPfad = Left(AppDataPfad, InStrRev(AppDataPfad, "\",-1, 1)) 	' AppDataPfad auf \appdata\ setzen
	End If
	' Standort info.json ermitteln
	If fso.FileExists(AppDataPfad & "Roaming\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "Roaming\Dropbox\info.json"
	end If
	If fso.FileExists(AppDataPfad & "Local\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "Local\Dropbox\info.json"
	end If
	If fso.FileExists(AppDataPfad & "LocalLow\Dropbox\info.json") Then
		DropInfo = AppDataPfad & "LocalLow\Dropbox\info.json"
	end If
	' Ermittlung Dropbox-Pfad aus der info.json
	' Annahme: Pfad steht nach dem String "path" zwischen dem folgenden beiden Anfhrungszeichen
	Set f = fso.OpenTextFile(DropInfo, ForReading)
	DropInfoText =   f.ReadAll
	' schrittweises Vorgehen, um evtl. individuelle Abweichungen abzufangen
	DropInfoText = Right(DropInfoText, Len (DropInfoText) - InStr(1, DropInfoText, "path", 1)-4)	'linken Teil bis path" abschneiden
	DropInfoText = Right(DropInfoText, Len (DropInfoText) - InStr(1,DropInfoText, Chr(34), 1))	'linken Teil bis nchstes " abschneiden
	DropBoxPfad = Left(DropInfoText, InStr(1,DropInfoText, Chr(34), 1)-1)	'linken Teil bis nchstes " retten
End Function

Sub Dialogaufbau
	'** Start Dialog Konfigurator **
	FF_AddDialog "Konfigurator",350,252
	FF_AddControl "Konfigurator","gespeicherte Ansichten ","GROUP",4,189,116,24
	FF_AddControl "Konfigurator","Skript-Tasten","GROUP",252,118,93,43
	FF_AddControl "Konfigurator"," FixFoto-Version","GROUP",182,229,78,19
	FF_AddControl "Konfigurator","Externe Programme","GROUP",252,167,93,43
	FF_AddControl "Konfigurator","Tastenbelegung","GROUP",252,70,93,43
	FF_AddControl "Konfigurator","eigene Dialog-Zusammenstellungen","GROUP",125,133,120,36
	FF_AddControl "Konfigurator","FTP-Einstellungen","GROUP",126,175,119,36
	FF_AddControl "Konfigurator","Optionen","GROUP",4,218,87,30
	FF_AddControl "Konfigurator","Voreinstellungen in den Dialogen / Textliste","GROUP",125,91,120,36
	FF_AddControl "Konfigurator","gespeicherte Ansichten","GROUP",125,23,120,62
	FF_AddControl "Konfigurator","Nummerierung in Computer-Ansicht","GROUP",252,21,93,24
	FF_AddControl "Konfigurator"," Farbsaumkorrektur-Profile","GROUP",4,161,116,24
	FF_AddControl "Konfigurator","Objektivkorrektur-Profile ","GROUP",4,133,116,24
	FF_AddControl "Konfigurator","Seitenausgabe Vorlagen","GROUP",4,105,116,24
	FF_AddControl "Konfigurator","Stapelverarbeitungen","GROUP",4,21,116,24
	FF_AddControl "Konfigurator","Makros","GROUP",4,49,116,24
	FF_AddControl "Konfigurator","Belichter-Formate","GROUP",4,77,116,24
	FF_AddControl "Konfigurator","belichter_combo","COMBO",8,86,90,10
	FF_AddControl "Konfigurator","Beenden","BUTTON",305,233,39,14
	FF_AddControl "Konfigurator","?","BUTTON",267,233,14,14
	FF_AddControl "Konfigurator","Lschen","BUTTON",102,84,13,13
	FF_AddControl "Konfigurator","makro_combo","COMBO",8,58,90,10
	FF_AddControl "Konfigurator","|Lschen","BUTTON",102,56,13,13
	FF_AddControl "Konfigurator","stapel_combo","COMBO",8,30,90,10
	FF_AddControl "Konfigurator","||Lschen","BUTTON",102,28,13,13
	FF_AddControl "Konfigurator","seiten_combo","COMBO",8,114,90,10
	FF_AddControl "Konfigurator","|||Lschen","BUTTON",103,112,13,13
	FF_AddControl "Konfigurator","obkor_combo","COMBO",8,142,90,10
	FF_AddControl "Konfigurator","||||Lschen","BUTTON",103,140,13,13
	FF_AddControl "Konfigurator","farbkor_combo","COMBO",8,170,90,10
	FF_AddControl "Konfigurator","|||||Lschen","BUTTON",103,168,13,13
	FF_AddControl "Konfigurator","numein_bool","BOOL",257,32,8,8
	FF_SetControlStyle "Konfigurator","numein_bool",16384
	FF_AddControl "Konfigurator","numaus_bool","BOOL",301,32,8,8
	FF_SetControlStyle "Konfigurator","numaus_bool",16384
	FF_AddControl "Konfigurator","einschalten","STATIC",267,30,29,11
	FF_AddControl "Konfigurator","ausschalten","STATIC",311,30,29,11
	FF_AddControl "Konfigurator","Sichern","BUTTON",148,30,33,10
	FF_AddControl "Konfigurator","Einlesen","BUTTON",189,30,33,10
	FF_AddControl "Konfigurator","|Sichern","BUTTON",135,101,33,10
	FF_AddControl "Konfigurator","|Einlesen","BUTTON",176,101,33,10
	FF_AddControl "Konfigurator","gesichert am:","STATIC",131,112,49,12
	FF_AddControl "Konfigurator","|gesichert am:","STATIC",131,41,49,12
	FF_AddControl "Konfigurator","ansichtsave","STATIC",170,41,32,11
	FF_SetControlStyle "Konfigurator","ansichtsave",0
	FF_AddControl "Konfigurator","dialogsave","STATIC",170,112,35,11
	FF_SetControlStyle "Konfigurator","dialogsave",0
	FF_AddControl "Konfigurator","Version","STATIC",286,234,14,11
	FF_AddControl "Konfigurator","heatline1_img","IMAGE",0,0,350,18
	FF_AddControl "Konfigurator","abfrag_bool","BOOL",11,226,8,8
	FF_AddControl "Konfigurator","mit Sicherheitsabfragen","STATIC",22,224,61,11
	FF_AddControl "Konfigurator","ffvers_dialog_stat","STATIC",200,112,37,11
	FF_SetControlStyle "Konfigurator","ffvers_dialog_stat",0
	FF_AddControl "Konfigurator","ffvers_ansicht_stat","STATIC",201,41,37,11
	FF_SetControlStyle "Konfigurator","ffvers_ansicht_stat",0
	FF_AddControl "Konfigurator","|||Sichern","BUTTON",135,185,33,10
	FF_AddControl "Konfigurator","|||Einlesen","BUTTON",176,185,33,10
	FF_AddControl "Konfigurator","|||gesichert am:","STATIC",133,196,49,12
	FF_AddControl "Konfigurator","ftp_save","STATIC",170,196,32,11
	FF_SetControlStyle "Konfigurator","ftp_save",0
	FF_AddControl "Konfigurator","ff_vers_ftp_save","STATIC",200,196,39,11
	FF_SetControlStyle "Konfigurator","ff_vers_ftp_save",0
	FF_AddControl "Konfigurator","ansichten_combo","COMBO",8,198,90,10
	FF_AddControl "Konfigurator","ansicht_del_button","BUTTON",102,196,13,13
	FF_AddControl "Konfigurator","||||Sichern","BUTTON",135,143,33,10
	FF_AddControl "Konfigurator","||||Einlesen","BUTTON",176,143,33,10
	FF_AddControl "Konfigurator","||||gesichert am:","STATIC",131,154,49,12
	FF_AddControl "Konfigurator","diazusave","STATIC",170,154,35,11
	FF_SetControlStyle "Konfigurator","diazusave",0
	FF_AddControl "Konfigurator","ffvers_diazu_stat","STATIC",200,154,37,11
	FF_SetControlStyle "Konfigurator","ffvers_diazu_stat",0
	FF_AddControl "Konfigurator","|||||Sichern","BUTTON",258,78,33,10
	FF_AddControl "Konfigurator","|||||Einlesen","BUTTON",299,78,33,10
	FF_AddControl "Konfigurator","|||||gesichert am:","STATIC",258,90,49,12
	FF_AddControl "Konfigurator","tastensave","STATIC",303,90,35,11
	FF_SetControlStyle "Konfigurator","tastensave",0
	FF_AddControl "Konfigurator","ff_vers_tast","STATIC",303,100,37,11
	FF_SetControlStyle "Konfigurator","ff_vers_tast",0
	FF_AddControl "Konfigurator","||||||Sichern","BUTTON",258,176,33,10
	FF_AddControl "Konfigurator","||||||Einlesen","BUTTON",299,176,33,10
	FF_AddControl "Konfigurator","||||||gesichert am:","STATIC",258,188,49,12
	FF_AddControl "Konfigurator","extpsave","STATIC",303,189,35,11
	FF_SetControlStyle "Konfigurator","extpsave",0
	FF_AddControl "Konfigurator","ff_vers_exp","STATIC",303,197,37,11
	FF_SetControlStyle "Konfigurator","ff_vers_exp",0
	FF_AddControl "Konfigurator","line","STATIC",0,216,350,4
	FF_SetControlStyle "Konfigurator","line",16
	FF_AddControl "Konfigurator","Daten && Skript in eine ZIP","BUTTON",99,233,74,14
	FF_AddControl "Konfigurator","aktFFVersion","STATIC",191,235,68,11
	FF_AddControl "Konfigurator","|||||||Sichern","BUTTON",258,127,33,10
	FF_AddControl "Konfigurator","|||||||Einlesen","BUTTON",299,127,33,10
	FF_AddControl "Konfigurator","|||||||gesichert am:","STATIC",258,140,49,12
	FF_AddControl "Konfigurator","stastensave","STATIC",302,140,35,11
	FF_SetControlStyle "Konfigurator","stastensave",1
	FF_AddControl "Konfigurator","ff_vers_stasten","STATIC",305,148,37,11
	FF_SetControlStyle "Konfigurator","ff_vers_stasten",0
	FF_AddControl "Konfigurator","Tooltipp in der Computeransicht","BUTTON",258,49,82,14
	FF_AddControl "Konfigurator","Set I","STATIC",132,29,13,11
	FF_AddControl "Konfigurator","Set II","STATIC",132,57,13,11
	FF_AddControl "Konfigurator","dropbox_bool","BOOL",11,237,8,8
	FF_AddControl "Konfigurator","Daten && Skript zu Dropbox","STATIC",22,235,67,11
	FF_AddControl "Konfigurator","||||||||Sichern","BUTTON",148,57,33,10
	FF_AddControl "Konfigurator","||||||||Einlesen","BUTTON",189,57,33,10
	FF_AddControl "Konfigurator","||||||||gesichert am:","STATIC",131,69,49,12
	FF_AddControl "Konfigurator","ffvers_ansicht_stat2","STATIC",201,69,38,11
	FF_SetControlStyle "Konfigurator","ffvers_ansicht_stat2",12
	FF_AddControl "Konfigurator","ansichtsave2","STATIC",170,69,29,11
	FF_SetControlStyle "Konfigurator","ansichtsave2",0
	'** End Dialog Konfigurator **
	
	REM FF_AddControl "Konfigurator","aktuelle Ansicht","GROUP",125,21,122,36
	REM FF_AddControl "Konfigurator","||Sichern","BUTTON",135,31,33,10
	REM FF_AddControl "Konfigurator","||Einlesen","BUTTON",176,31,33,10
	REM FF_AddControl "Konfigurator","||gesichert am:","STATIC",131,42,49,12
	REM FF_AddControl "Konfigurator","akutansichtsave","STATIC",170,42,32,11
	REM FF_AddControl "Konfigurator","ffvers_akutansicht_stat","STATIC",200,42,37,11
	
	FF_SetControl "Konfigurator","heatline1_img", FF_GetFFPathEx(2) & "\Konfigurator\" & HeadImage
	FF_SetControlImage "Konfigurator", "Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "|Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "||Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "|||Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "||||Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "|||||Lschen", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
	FF_SetControlImage "Konfigurator", "ansicht_del_button", FF_GetFFPathEx(2) & "\Konfigurator\" & ButImage1
		
	If Version_equal_or_better("3.30.06") Then 			' Tooltipps erst ab 3.30 beta 6
		FF_SetControlTooltip "Konfigurator","Sichern","gespeicherte Einstellungen der Mens und Symbolleisten"
		FF_SetControlTooltip "Konfigurator","||||||||Sichern","gespeicherte Einstellungen der Mens und Symbolleisten"
		FF_SetControlTooltip "Konfigurator","|Sichern","gespeicherte Voreinstellungen in den Dialogen / Eintrge in der Texteingabebox"
		FF_SetControlTooltip "Konfigurator","|||Sichern","FTP-Einstellungen fr Web-Listen und im Dialog 'Speichern unter'"
		FF_SetControlTooltip "Konfigurator","||||Sichern","Zusammenstellungen fr Benutzerdialog, Stereodialog und Retuschedialog"
		FF_SetControlTooltip "Konfigurator","|||||Sichern","individuelle Tastenkombinationen"
		FF_SetControlTooltip "Konfigurator","|||||||Sichern","gespeicherter Schnellstart von Skripten per Tastenkombination (F10)"
		FF_SetControlTooltip "Konfigurator","||||||Sichern","Einstellungen zum Aufruf externer Programme"
		FF_SetControlTooltip "Konfigurator","numein_bool","Aktiviert fortlaufende Nummerierung der Bilder in Computeransicht und Bilderliste"
		FF_SetControlTooltip "Konfigurator","dropbox_bool","Beim Beenden werden alle gesicherten Daten und das Skript selbst in den lokalen Dropbox-Ordner unter \Konfigurator\jjmmdd\ kopiert."
		FF_SetControlTooltip "Konfigurator","Daten && Skript in eine ZIP","Umzugsservice fr die gespeicherten Daten" & vbNewLine & "Alle gesicherten Daten und das Skript selbst werden in ein ZIP-Archiv kopiert." 
				
		Call Tooltipp_Ansichten		' ausgelagert, weil auch spter noch zu aktualisieren
	End If	
End Sub

Sub Tooltipp_Ansichten
	If Version_equal_or_better("3.30.06") Then 			' Tooltipps erst ab 3.30 beta 6
		FF_SetControlTooltip "Konfigurator","Einlesen", Replace(ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten", "Tooltip"), "", vbNewLine)
		FF_SetControlTooltip "Konfigurator","||||||||Einlesen", Replace(ReadIni(FF_GetFFPathEx(2) & "\Konfigurator\konfigurator.ini", "Ansichten2", "Tooltip"), "", vbNewLine)
	End If
End Sub
